<template>
	<div class="form" :class="[`form--type-${type}`, `form--o-${orientation}`]">

		<h3 v-if="title" class="form__title" v-html="title"></h3>
		<div v-if="subtitle" class="form__subtitle" v-html="subtitle"></div>

		<template v-if="type == 'default'">
			<div class="form__item">
				<div class="form__item__label">Ваше имя:</div>
				<div class="form__item__field">
					<input type="text" name="name" placeholder="Илон Маск" v-model="form.name">
				</div>
			</div>

			<div class="form__item">
				<div class="form__item__label">Ваш email:</div>
				<div class="form__item__field">
					<input type="email" name="email" placeholder="elon@tesla.com" v-model="form.email">
					<!-- <div class="form__item__field__help">К сожалению, почта на Gmail не всегда отрабатывает идеально. Если есть другая, лучше указать её.</div> -->
				</div>
			</div>

			<div class="form__item form__item--button">
				<button class="button" :disabled="!isValid" :class="{'button--loading': loading}" @click="send">{{ button }}</button>
			</div>
			<div class="form__disclaimer">
				Отправляя данную форму, вы даёте своё согласие на обработку персональных данных и получение электронных писем.
				<div class="form__disclaimer__errors"></div>
			</div>
		</template>

		<template v-else-if="type == 'messengers'">
			<div class="form__item form__item--button form__item--button--messenger" v-for="(m, i) in messengers" :key="i">
				<a @click="trackLead" :href="m.link" target="_blank" class="button" :class="[`button--${m.social}`]">{{ m.text }}</a>
			</div>
			<div class="form__disclaimer">
				Подписываясь на уведомления в мессенджере, вы даёте своё согласие на обработку персональных данных и получение электронных писем.
			</div>
		</template>

		<product-form v-else-if="type == 'payment'" :product_id="product_id" :promocodes="promocodes" :styled="styled" :success_url="success_url" />


	</div>
</template>

<script>
import ProductForm from './ProductForm.vue';
export default {
  components: { ProductForm },
	props: {
		orientation: {
			default: "h"
		},
		type: {
			default: "default"
		},
		sendpulse_list: {
			default: null
		},
		carrotquest_event: {
			default: null
		},
		title: {},
		subtitle: {},
		redirect: {},
		button: {
			default: 'Отправить'
		},
		messengers: {},
		product_id: {
			default: null
		},
		promocodes: {
			default: true
		},
		styled: {
			default: false
		},
		success_url: {
			default: null
		}

	},

	data() {
		return {
			loading: false,
			form: {
				email: null,
				name: null
			}
		}
	},

	computed: {
		isValid() {
			switch (this.type) {
				default:
					return String(this.form.email).match(/([a-zA-Z0-9._+-]+@[a-zA-Z0-9._-]+\.[a-zA-Z0-9._-]+)/gi) && this.form.name;
					break;
			}
		}
	},

	methods: {
		trackLead() {
			if (this.carrotquest_event && typeof window.carrotquest != 'undefined') {
				window.carrotquest.track(this.carrotquest_event);
			}

			if (typeof window.fbq != 'undefined') {
				window.fbq('track', 'Lead');
			}
		},

		send() {
			this.loading = true;
			this.trackLead();

			if (this.sendpulse_list) {
				this.$axios.post('https://s.va-promotion.ru/api/sendpulse', {
					email: this.form.email,
					list_id: this.sendpulse_list,
					name: this.form.name
				}).then(r => {
					window.location.href = this.redirect;
				}).catch(e => {

				});
			} else {
				setTimeout(() => {
					window.location.href = this.redirect;
				}, 1000);
			}

		}
	},
}
</script>

<style lang="scss">
@import "~/assets/scss/ui/button";

.form {
	&__title {
		font-weight: 800;
		@include xs {
			font-size: 18px;
		}
	}
	&__subtitle {
		font-size: 14px;
		opacity: .7;
		line-height: 1.55;
		margin-top: 5px;
	}
	&__item {
		&__label {
			font-size: 11px;
			margin-bottom: 5px;
			text-transform: uppercase;
			font-weight: 500;
			letter-spacing: 0.1em;
		}
		&__field {
			input {
				appearance: none;
				outline: none;
				height: 54px;
				padding: 15px 25px;
				background-color: #fff;
				font-family: $sans;
				display: block;
				font-size: 15px;
				border: 1px solid rgba($primary, .3);
				box-shadow: none;
				width: 100%;
				border-radius: 4px;
				&:focus {
					border-color: var(--primary);
					z-index: 100;
				}

				@include xs {
					height: 50px;
					padding: 12px 20px;
					font-size: 14px;
				}
			}

			&__help {
				font-size: 12px;
				color: #666;
				line-height: 1.5;
				margin-top: 8px;
			}
		}
		&--button {
			button, a {
				height: 54px;
				@include xs {
					height: 50px;
					width: 100%;
				}
			}

			&--messenger {
				button, a {
					width: 100%;
					text-align: center;

					&.button--telegram {
						background-color: #0088cc;
					}
				}
			}
		}
	}
}


.form--o {

	&-v {
		.form {
			&__item {
				margin-top: 25px;
				&:first-child {
					margin-top: 0;
				}

				&--button {
				}


			}

			&__disclaimer {
				font-size: 11px;
				opacity: .7;
				line-height: 1.55;
				margin-top: 20px;
			}
		}
	}

	&-h {
		display: flex;
		flex-direction: row;
		align-items: flex-end;

		.form {
			&__item {
				flex-grow: 1;
				margin-right: -1px;

				&__field {
					input {
						border-radius: 0px;
					}
				}

				&:first-child {
					.form__item__field input {
						border-radius: 4px 0px 0px 4px;
					}
				}

				&--button {
					button {
						width: 100%;
						border-radius: 0px 4px 4px 0px;
					}
				}
			}
		}

	}
}
</style>
